package com.qmth.themis.business.service.impl;

import java.util.Date;
import java.util.Map;

import javax.annotation.Resource;

import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.themis.business.cache.RedisKeyHelper;
import com.qmth.themis.business.cache.bean.ExamRecordCacheBean;
import com.qmth.themis.business.dao.TOeExamRecordMapper;
import com.qmth.themis.business.entity.TOeExamRecord;
import com.qmth.themis.business.service.TOeExamRecordService;
import com.qmth.themis.business.util.RedisUtil;

/**
 * @Description: 考试记录 服务实现类
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2020/6/25
 */
@Service
public class TOeExamRecordServiceImpl extends ServiceImpl<TOeExamRecordMapper, TOeExamRecord> implements TOeExamRecordService {

    @Resource
    TOeExamRecordMapper tOeExamRecordMapper;
    
    @Resource
    RedisUtil redisUtil;

    @Override
    public Map getUnFinishExam(Long studentId) {
        return tOeExamRecordMapper.getUnFinishExam(studentId);
    }
    
    @Transactional 
    @Override
    public Long saveByPrepare(Long examId,Long examActivityId,Long examStudentId,Long paperId,Integer serialNumber) {
    	TOeExamRecord er=new TOeExamRecord();
    	er.setExamId(examId);
    	er.setExamActivityId(examActivityId);
    	er.setExamStudentId(examStudentId);
    	er.setPaperId(paperId);
    	er.setSerialNumber(serialNumber);
    	er.setFirstPrepareTime(new Date());
    	er.setStatus(0);
    	saveOrUpdate(er);
    	ExamRecordCacheBean erCache=new ExamRecordCacheBean();
    	erCache.setId(er.getId());
    	erCache.setExamId(examId);
    	erCache.setExamActivityId(examActivityId);
    	erCache.setExamStudentId(examStudentId);
    	erCache.setPaperId(paperId);
    	erCache.setSerialNumber(serialNumber);
    	erCache.setFirstPrepareTime(new Date());
    	erCache.setStatus(0);
    	redisUtil.set(RedisKeyHelper.examRecordCacheKey(er.getId()), erCache);
    	return er.getId();
    }
}
